<?
// CNS / Minithins monolyth
// minithins.php - fonctions script

// Don't ignore the power of the dark side
//   -- darkmyc

class minithins 
{
  var $style_class;
  var $section;

  var $use_mcrypt = 1;

  function minithins ()
  { 
    global $highenc;

    if ($this->check_for_mcrypt() && $highenc)
      $this->use_mcrypt = 1; 
    else
      $this->use_mcrypt = 0;
  }
 
  function check_for_mcrypt ()
  {
    $arr = get_defined_functions ();
    for ($i = 0; $arr["internal"][$i] != ""; $i++)
      if ($arr["internal"][$i] == "mcrypt_encrypt")
        return 1;

    return 0;  
  }

  function version ()
  {
    global $VERSION;
    return $VERSION;
  }

  /***********************************************************************/

  function clearpass_to_in_dbpass ($password)
  {
    if (strlen ($password) < 2)
      return ("youknowitisnotright");

    if ($this->use_mcrypt)
    {
      $initiv = mcrypt_create_iv (mcrypt_get_iv_size (MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND);

      $md5pass = md5($password);
      $passdb = mcrypt_encrypt (MCRYPT_RIJNDAEL_256, $md5pass, $password, MCRYPT_MODE_ECB, $initiv);
    }
    else
    {
      $salt1 = "";
      $salt2 = "";
      $salt1[0] = $password[0];
      $salt1[1] = $password[1]; 
      $passint = crypt ($password, $salt1);
      $salt2[0] = $passint[2];
      $salt2[1] = $passint[3];
      $passdb = crypt ($password, $salt2);
    }
    return (md5($passdb));
  }

  function db_open ()
  {
    global $DB_HOST, $DB_USER, $DB_NAME, $DB_PASS, $DB_LINK;

    $DB_LINK = pg_connect("host=".$DB_HOST." port=5432 user=".$DB_USER." password=".$DB_PASS." dbname=".$DB_NAME) or $this->die_error("Database error.");

    return ;
  }

  function db_open_forum ()
  {
    global $DBF_HOST, $DBF_USER, $DBF_NAME, $DBF_PASS, $DBF_LINK;

    $DBF_LINK = pg_connect("host=".$DBF_HOST." port=5432 user=".$DBF_USER." password=".$DBF_PASS." dbname=".$DBF_NAME) or $this->die_error("Database error.");

    return ;
  }

  function db_close ()
  {
    global $DB_LINK;
    pg_close ($DB_LINK);
  }

  function db_close_forum ()
  {
    global $DBF_LINK;
    pg_close ($DBF_LINK);
  }

  function db_query ($sql)
  {
    global $DB_LINK;

    $resultat = pg_exec($DB_LINK, $sql)
      or $this->die_error("Database error.");
    return ($resultat);
  }

  function db_query_forum ($sql)
  {
    global $DBF_LINK;
    $resultat = pg_exec($DBF_LINK, $sql)
      or $this->die_error("Database error.");
    return ($resultat);
  }

  function forbid_adm ()
  {
    global $_SERVER;
    global $SERVER_PORT;
    global $only_on_port;

    $name = $_SERVER["HTTP_HOST"];

    if (ereg ("(.*):([0-9]{1,5})", $name, $port) == TRUE)
    {
      if ($port[2] != $only_on_port)
      {
        return (1);
      }
    }
    else
    {
      if ($SERVER_PORT != $only_on_port)
      {
        return (1);
      }
    }
    return (0);
  }

  function forbid ()
  {
    global $REMOTE_ADDR;
    $havetoban = 0;

    $addr = gethostbyname($REMOTE_ADDR);
    $beautifulhost = gethostbyaddr ($addr);

    $r = $this->db_query ("select * from forbid;");

    if (pg_numrows($r) == 0)
      return (0);

    for ($i = 0; $i < pg_numrows($r); $i ++)
    {
      $t = pg_Fetch_Array($r, $i);
      if (ereg ($t['host'], $addr))
        $havetoban = 1;
      if (ereg ($t['host'], $beautifulhost))
        $havetoban = 1;
    }

    if (!$havetoban) return (0);

    echo "<br><br>";
    echo "<div align=center>";
    echo "Consulting http://www.minithins.net/ from '$beautifulhost' is not allowed.";
    echo "</div>";

    return 1;
  }

  /***********************************************************************/

  function die_error ($string)
  {
    echo "$string\n<br>";
    die ();
  }

  function set_style ($style_class)
  {
    $this->style_class = $style_class;
  }

  function show_style ()
  {
  }

  function get_section ()
  {
    return ($this->section);
  }

  function list_style ()
  {
    global $base_site;

    $dir = opendir ($base_site."/styles/");

    while ($file = readdir ($dir))
    {
      if ($file[0] != '.')
        echo "$file\n<br>";
    }

    closedir ($dir);
  }

  /***********************************************************************/

  function start ($section = "")
  {
    global $use_forum;
    $this->section = $section;
    $this->db_open ();

    $this->style_class->html_start ();

    if ($this->forbid ())
      return 0;

    switch ($section)
    {
      default:
      case "index":
        $this->news_show ();
      break;

      case "releases":
        $this->list_releases ();
        $this->releases_feet ();
      break;

      case "papers":
        $this->list_papers ();
        $this->papers_feet ();
      break;

      case "projects":
        $this->list_projets ();
      break;

      case "kb":
        $this->list_urls ();
      break;

      case "forum";
        if ($use_forum)
        {
          $this->db_open_forum ();
          _forum (); 
          $this->db_close_forum ();
        }
        else
          $this->news_show ();
      break;
 
      case "about":include ("static/about.php");
      break;
    }

    $this->style_class->html_stop ();
  } 

  function stop ()
  {
    $this->db_close ();
  }

  /***********************************************************************/

  function db_stamp_to_timestamp ($t)
  {
    $timestamp = mktime (substr($t, 11, 2), substr($t, 14, 2), 
      substr($t, 17, 2), substr($t, 5, 2), 
      substr($t, 8, 2), substr($t, 0, 4));
    
    return $timestamp;
  }

  function news_date_format ($t)
  {
    $m = date ("j/n/Y", $t);
    return ($m);
  }

  /***********************************************************************/

  function list_urls ()
  {
    $r1 = $this->db_query ("select id, ordre, nom, tag from url_section order by ordre desc;");

    $this->style_class->start_list_url_section ();
    for ($i = 0; $i < pg_numrows ($r1); $i ++)
    {
      $t1 = pg_Fetch_Array($r1, $i);
      if ($t1['ordre'])
        $this->style_class->list_url_section ($t1);
    }
    $this->style_class->end_list_url_section ();

    for ($i = 0; $i < pg_numrows ($r1); $i ++)
    {
      $t1 = pg_Fetch_Array($r1, $i);
      if ($t1['ordre'])
      {
        $this->style_class->start_url_section ($t1['nom'], $t1['tag']);

        $r2 = $this->db_query ("select url, nom_url, url_section, auteur from urls where lang=0 and url_section=".$t1['id'].";");

        if (pg_numrows ($r2) > 0)
        {

          $this->style_class->start_url_tableau ();
          for ($g = 0; $g < pg_numrows ($r2); $g ++)
          {
            $t2 = pg_Fetch_Array($r2, $g);
            $this->style_class->show_url ($t2);
          }
          $this->style_class->end_url_tableau ();
        }

        $r2 = $this->db_query ("select url, nom_url, url_section, auteur from urls where lang=1 and url_section=".$t1['id'].";");

        if (pg_numrows ($r2) > 0)
        {
          $this->style_class->start_url_tableau ();
          for ($g = 0; $g < pg_numrows ($r2); $g ++)
          { 
            $t2 = pg_Fetch_Array($r2, $g);
            $this->style_class->show_url ($t2);
          }
          $this->style_class->end_url_tableau ();
        }
        $this->style_class->end_url_section (); 
      }
    }
  }

  function list_projets ()
  {
    $r = $this->db_query ("select * from projets order by ordre desc;");
    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      $t = pg_Fetch_Array ($r, $i);
      if ($t['ordre'])
        $this->style_class->show_projet ($t);
    }
  }

  function list_releases ()
  {
    $r = $this->db_query ("select * from releases order by ordre desc;");
    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      $t = pg_Fetch_Array ($r, $i);
      if ($t['ordre'])
        $this->style_class->show_release ($t);
    }
  }

  function releases_feet ()
  {
    $this->style_class->feet_releases ();
  }

  function list_papers ()
  {
    $r = $this->db_query ("select * from papers order by ordre desc;");
    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      $t = pg_Fetch_Array ($r, $i);
      if ($t['ordre'])
        $this->style_class->show_paper ($t);
    }
  }

  function papers_feet ()
  {
    $this->style_class->feet_papers ();
  }

  /***********************************************************************/

  // News related functions

  function news_show ()
  {
    $r = 
     $this->db_query("select * from news where ordre <> 0 order by ordre asc");
    $max = 20;

    if (pg_numrows($r) < $max)
      $max = pg_numrows($r);

    for ($i = $max - 1; $i >= 0; $i --)
    {
      $t = pg_Fetch_Array ($r, $i);
      $tmp = $this->db_stamp_to_timestamp($t['timestamp']);
      $date = $this->news_date_format ($tmp); 

      $this->style_class->show_new ($t, $date);
    } 

    return ;
  }
 
  function news_admin_list ()
  {
    global $news_action, $news_id;
    $r = 
     $this->db_query("select * from news where ordre <> 0 order by ordre desc");

?><div align=left><table border=1><?

    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      $t = pg_Fetch_Array ($r, $i);

?><tr>
<td><?echo $t['title'];?></td>
<td><?
  echo $this->news_date_format($this->db_stamp_to_timestamp($t['timestamp']));
?></td>
<td>
 <a href=adm.php?p=news&news_action=modify&news_id=<?echo $t['id'];?>>Modifier</a></td>
<td>Cacher</td>
<td>
 <a href=adm.php?p=news&news_action=del&news_id=<?echo $t['id'];?>>Effacer</a>
</td>
<td><?if ($i == 0) echo "&nbsp;"; else echo "+";?></td>
<td><?if ($i == (pg_numrows($r) - 1)) echo "&nbsp"; else echo "-";?></td>
</tr><?
    }

?></table></div><?

    // formulaire d'ajout
    if ($news_action != "modify")
    {
?>
<br><br>
<b>Ajout d'une nouvelle:</b><br><br>
<form method=POST action=adm.php?p=news&news_action=add>
Titre:<br><input type=text size=50 name=news_title><br>
Corps: (format html, balises  inclure)<br>
<textarea rows=30 cols=120 name=news_body></textarea><br>
<input type=submit value='Ajouter'>
</form>
<?
    }
    else
    {
    $r = $this->db_query ("select * from news where id=$news_id;");
    $t = pg_Fetch_Array ($r, 0);
?>
<br><br>
<b>Modification d'une nouvelle:</b><br><br>
<form method=POST action=adm.php?p=news&news_action=modify&news_id=<?echo $t['id'];?>>
Titre:<br><input type=text size=50 name=news_title value='<?echo $t['title'];?>'><br>
Corps: (format html, balises  inclure)<br>
<textarea rows=30 cols=120 name=news_body><?echo $t['body'];?></textarea><br>
<input type=hidden name=news_confirm value=1>
<input type=submit value='Modifier'>
</form>
<br><br>
<a href=adm.php?p=news>Retour  la gestion des news</a>
<?
    }
    return ;
  }

  function modify_news_admin ()
  {
    global $news_confirm, $news_id;
    global $news_body, $news_title;

    $this->db_query ("update news set title = '$news_title', body = '$news_body' where id=$news_id;");
    echo "Nouvelle mise  jour.";
  }

  function add_news_admin ()
  {
    global $news_title, $news_body;
    global $REQUEST_METHOD;
    if ($REQUEST_METHOD != "POST")
      return ;

    $r = $this->db_query ("select ordre from news where ordre <> 0;");
    $nbr = pg_numrows ($r);
    $nbr ++;
    $r = $this->db_query("insert into news (title, body, ordre) values ('".$news_title."', '".$news_body."', ".$nbr.");");
    if ($r) echo "Nouvelle ajoute.";
  }

  function del_news_admin ()
  {
    global $news_confirm, $news_id;

    $r = $this->db_query ("select title from news where id=$news_id;");
    if (pg_numrows ($r) != 1)
    {
      echo "Pas de news avec l'id '$news_id'<br>\n";
      return ;
    }

    $t = pg_Fetch_Array ($r, 0); 
    if ($news_confirm != 1)
    {
?>
<form method=POST action=adm.php?p=news&news_action=del&news_id=<?echo $news_id;?>>
Effacer la nouvelle '<?echo $t['title'];?>' ?<br>
<input type=hidden name=news_confirm value=1>
<input type=submit value='Effacer'>
</form>
<?
    }
    else
    {
      $this->db_query ("delete from news where id=$news_id;");
      echo "Effac ...";
    }
?>
<br><br>
<a href=adm.php?p=news>Retour  la gestion des news</a>
<?
  }

  /************************************************************************/

  function user_admin ()
  {
    global $user_action;
    global $password;

    switch ($user_action)
    {
      default:
?>
<br><b>Administration des utilisateurs</b><br><br>
<a href=adm.php?p=user&user_action=chpass>Changer votre mot de passe</a>
<br><br>
<form method=POST action=adm.php?p=user&user_action=generate>
<input type=password name=password>
<input type=submit value='voir'>
</form>
<?
      break;

      case "generate":
        echo "Password crypt: ".$this->clearpass_to_in_dbpass ("$password");
      break;

      case "chpass":
        global $REQUEST_METHOD, $adm_user;
        if ($REQUEST_METHOD != "POST")
        {
?>
<form method=POST action=adm.php?p=user&user_action=chpass>
<table border=0>
<tr>
  <td>Password actuel: </td>
  <td><input type=password name=user_pass_act></td>
</tr><tr>
  <td>Nouveau password: </td>
  <td><input type=password name=user_new_pass></td>
</tr><tr>
  <td>Confirmation password: </td>
  <td><input type=password name=user_new_cofm></td>
</tr><tr>
  <td colspan=2>
    <input type=submit value='Valider'>
  </td>
</tr>
</table>
<?
        }
        else
        {
          global $user_pass_act, $user_new_pass, $user_new_cofm;
          $test = 1;
          if ($user_new_pass != $user_new_cofm)
            $test = 0;
          if ($test) 
          {
            $user_pass_act = secure_txt ($user_pass_act);
            $ipass = $this->clearpass_to_in_dbpass ($user_pass_act);
            $r = $this->db_query ("select * from users where username='$adm_user' and pass='$ipass';");
            if (pg_numrows($r) != 1)
              $test = 0;
            if ($test)
            {
              $epass = $this->clearpass_to_in_dbpass ($user_new_cofm);
              $r = $this->db_query ("update users set pass='$epass' where username='$adm_user';");
              echo "Mot de pass chang.<br>";
            }
          }
          if (!$test)
            echo "Erreur dans le changement de mot de pass.<br>";
        }
      break;
    }

    echo "<br><br><a href=adm.php>Retour au menu principal</a><br>";
  }

  function news_admin ()
  {
    global $news_action, $news_id, $news_confirm;
    echo "<br><b>Administration du menu</b><br><br>";

    switch ($news_action)
    {
      default:
        $this->news_admin_list ();
      break;

      case "add":
        $this->add_news_admin ();
        $this->news_admin_list ();
      break;
      case "del":
        $this->del_news_admin ();
      break;
      case "modify":
        if ($news_confirm == 1) 
          $this->modify_news_admin ();

        $this->news_admin_list ();
      break;
      case "ordplus": /* todo */
      break;
      case "ordmoins": /* todo */
      break;
      case "afcach": /* todo */
      break;
    }

    echo "<br><br><a href=adm.php>Retour au menu principal</a><br>";
  }

  /***********************************************************************/

  function admin_case ($menu)
  {
    global $adm_user;

    switch ($menu)
    {
      default:
        return 0;
      break;

      case "news":
        $this->news_admin ();
        return 1;
      break;

      case "releases":
        $this->releases_admin ();
        return 1;
      break;

      case "papers":
        $this->papers_admin ();
        return 1;
      break;

      case "projects":
        $this->projects_admin ();
        return 1;
      break;

      case "kb":
        $this->kb_admin ();
        return 1;
      break;

      case "up":
        $this->up_admin ();
        return 1;
      break;

      case "about":
        $this->about_admin ();
        return 1;
      break;

      case "todo":
        $this->todo_admin ();
        return 1;
      break;

      case "user":
        $this->user_admin ();
        return 1;
      break;

      case "sql":
        $this->sql_admin ();
        return 1;
      break;

      case "forbid":
        $this->forbid_admin ();
        return 1;
      break;

      case "logout":
        $adm_user = "";
        session_unregister("adm_user");
        Header("Location: http://www.minithins.net/");
        return 1;
      break;
    }

    return 0;
  }

  function admin_menu ()
  {
    global $mode_debug;
?>
<br><b>Menu admin. <u>minithins.net</u> (CNS/Minithins monolyth <?echo $this->version ();?>)</b><br>
<?if ($mode_debug == 1) echo "Mode debug.<br>";?>
<?if ($this->use_mcrypt == 1) echo "Utilisation du cryptage intensif pour les mots de passes.<br>";?>
<br>
<a href=adm.php?p=news>Gestion des nouvelles</a><br>
<a href=adm.php?p=releases>Gestion des releases</a><br>
<a href=adm.php?p=papers>Gestion des papers</a><br>
<a href=adm.php?p=projects>Gestion des projects</a><br>
<a href=adm.php?p=kb>Gestion de la knowledge base</a>&nbsp;(<a href=adm.php?p=kb&kb_action=kb_add>Ajout</a>)<br>
<a href=adm.php?p=up>Upload d'un fichier</a><br>
<a href=adm.php?p=todo>CNS/todo</a><br>
<a href=adm.php?p=about>Modification about.php</a><br>
<a href=adm.php?p=forbid>Accs  minithins.net/</a><br><br>
<a href=adm.php?p=sql>Console PGsql</a><br>
<a href=adm.php?p=user>Gestion des users</a><br>
<a href=adm.php?p=logout>Logout</a><br>
<br><br><br>
<?
  }

  /************************************************************************/

  function is_admin_logged ()
  {
    if (session_is_registered ("adm_user"))
      return 1;
    return 0;
  }

  function secure_txt ($text)
  {

    $text = ereg_replace ('\'', "", $text);
    $text = ereg_replace ('\|', "", $text);
    $text = ereg_replace ('#', "", $text);
    $text = ereg_replace (';', "", $text);
    $text = ereg_replace ('\\\\', "", $text);
    $text = ereg_replace ('--', "", $text);

    return ($text);
  }

  function verify_login ($login, $pass)
  {
    global $adm_user;
/*
        2. Server scripts must NOT check both $login and $password for bad
  characters in variables, as ' ; ) " # | and all those characters will
  fool the database parser.
 */
    $login = $this->secure_txt ($login);
    $pass = $this->secure_txt ($pass);

    $npass = $this->clearpass_to_in_dbpass($pass);
    $r = $this->db_query("select * from users where username='".$login."' and pass='".$npass."';");

    if (pg_numrows($r) == 1)
    {
      $adm_user = $login; 
      session_register ("adm_user");
      return 1;
    }

    return 0;
  }

  function show_login_procedure ()
  {
?>
<html>
<body bgcolor=#FFFFFF>
<div align=center>
<form method=POST action=adm.php>
<table border=0>
<input type=hidden name=mnt_val value='hihi'>
<tr><td>
Login:
</td><td>
<input type=text name=mnt_login value=''>
</td></tr>
<tr><td>
Pass:
</td><td>
<input type=password name=mnt_pass value=''>
</td></tr>
<tr><td colspan=2>
<div align=center>
<input type=submit value='Valider'>
</div>
</td></tr>
</form>
</div>
</body>
</html>
<?
  }

  /************************************************************************/

  function todo_admin ()
  {
    global $REQUEST_METHOD;
    global $cns_todo, $todo_form;

    if ($REQUEST_METHOD == "POST")
    {
      if ($todo_form != "")
      {
        $contents = eregi_replace("\\\'", "'", $todo_form);
        $contents = eregi_replace('\\\"', '"', $contents);
        $contents = eregi_replace('\\\\\\\\', '\\', $contents);

        $f = fopen ($cns_todo, "w");
        fwrite ($f, $contents, strlen ($contents));
        fclose ($f);
      }
    }

?>
<br><b>Modification du CNStodo.txt</b><br><br>
<form method=POST action=adm.php?p=todo>
<textarea name=todo_form rows=50 cols=100>
<?

$f = fopen ($cns_todo, "r");
$contents = fread($f, filesize ($cns_todo));
$contents = eregi_replace("\\'", "'", $contents);
echo $contents;
fclose ($f);

?>
</textarea><br>
<input type=submit value='Modifier'>
</form>
<?
  echo "<br><a href=adm.php>Retour au menu principal</a><br>";
  }

  /************************************************************************/

  function about_admin ()
  {
    global $REQUEST_METHOD;
    global $cns_about, $todo_form;

    if ($REQUEST_METHOD == "POST")
    {
      if ($todo_form != "")
      {
        $contents = eregi_replace("\\\'", "'", $todo_form);
        $contents = eregi_replace('\\\"', '"', $contents);
        $contents = eregi_replace('\\\\\\\\', '\\', $contents);

        $f = fopen ($cns_about, "w");
        fwrite ($f, $contents, strlen ($contents));
        fclose ($f);
      }
    }

?>
<br><b>Modification du about.php</b><br><br>
<form method=POST action=adm.php?p=about>
<textarea name=todo_form rows=50 cols=100>
<?

$f = fopen ($cns_about, "r");
$contents = fread($f, filesize ($cns_about));
$contents = eregi_replace("\\'", "'", $contents);
echo $contents;
fclose ($f);

?>
</textarea><br>
<input type=submit value='Modifier'>
</form>
<?
  echo "<br><a href=adm.php>Retour au menu principal</a><br>";
  }

  /************************************************************************/

  function up_admin ()
  {
    global $cns_upload, $REQUEST_METHOD, $base_site, $base_write;
    global $f_file, $f_file_name, $f_dir;
?>
<br><b>Upload de fichiers</b><br><br>
<?
    if ($REQUEST_METHOD == "POST")
    {
      if (!file_exists ($f_file))
        echo "Soucis.<br><br>";
      else
      {
        $destfile = "$base_site"."$f_dir/"."$f_file_name";
        while (ereg ("\.\.", $destfile) == 1)
          $destfile = ereg_replace ("\/[^/]*\/\.\.", "", $destfile); 

        if (ereg ("^$base_write", "$destfile") == 1)
        {
          copy ("$f_file", $destfile);
          if (file_exists($destfile))
            echo "Fichier upload.";
        }
        else
        {
          echo "Ne peut etre upload pour des raisons de scurite.";
        }
      }
    }
?>
(Merci de ne pas uploader par cette interface des fichiers de plus de 200 ko,
sauf si vous pouvez les faire en moins de 30 secondes. La cration de 
rpertoires est impossible.)<br><br>
<table border=0>
<form method=POST action=adm.php?p=up enctype="multipart/form-data">
<input type=hidden name=MAX_FILE_SIZE value=1048576>
<tr><td>Fichier:</td><td><input type=file name=f_file></td></tr>
<tr><td>Section:</td><td><select name=f_dir>
<?
  foreach ($cns_upload as $ndir => $dir)
  {
    echo "<option value='$dir'>".$ndir."\n";
    $l = opendir ($dir);

    while ($f = readdir ($l))
    {
      if (is_dir($dir.$f) && $f[0] != ".")
      {
        echo "<option value='$dir/$f'>".$ndir."/".$f."\n";
      }
    }
  }
?>
</select></td></tr>
<tr><td colspan=2>
<div align=center><input type=submit value=uploader></div>
</td></tr>
</form>
</table>
<?
    echo "<br><a href=adm.php>Retour au menu principal</a><br>";
    return ;
  }

  /***********************************************************************/

  function kb_admin ()
  {
    global $kb_action;

    echo "<br><b>Administration de la base de connaissances.</b><br>";
    echo "<a href=adm.php?z=kb&kb_action=kb_list>Listing</a>&nbsp;<a href=adm.php?z=kb&kb_action=kb_add>Ajout</a><br><br>";
    switch ($kb_action)
    {
      case 'kb_add':
        $this->kb_add_admin ();
      break;
      case 'kb_list':
      default:
        $this->kb_list_admin ();
      break;
    }
    echo "<br><a href=adm.php>Retour au menu principal</a><br>";
    return ;
  }

  function kb_list_admin ()
  {
    global $kb_action, $kb_id;
    switch ($kb_action)
    {
      case 'erase';
        if ($kb_id)
        {
          $r = $this->db_query ("delete from urls where id = $kb_id;");
          if ($r) echo "Effacement enregistrement $kb_id effectu.<br>";
          else echo "Erreur dans l'effacement.<br>";
          echo "<br>";
        }
      break;
      default:
      break;
    }
    $r = $this->db_query ("select * from url_section order by ordre desc;");
    echo "<b>Sections</b><br>\n";
    echo "<table border=1>\n";
    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      $t = pg_Fetch_Array ($r, $i);
      echo "<tr><td>".$t['nom']."</td>";
      echo "<td>effacer</td>";
      echo "<td>vider</td>";
      echo "<td>+</td>";
      echo "<td>-</td>";
      echo "</tr>\n";
    }
    echo "</table><br>\n";

    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      $t = pg_Fetch_Array ($r, $i);
      echo "<br><br>Section: <b>".$t['nom']."</b><br>";
      $r2 = $this->db_query ("select * from urls where url_section=".$t['id'].";");

      echo "<table border=1>\n";
      for ($j = 0; $j < pg_numrows ($r2); $j ++)
      {
        $t2 = pg_Fetch_Array ($r2, $j);
        echo "<tr><td><a href=".$t2['url'].">".$t2['nom_url']."</a></td>";
        echo "<td><a href=\"adm.php?p=kb&kb_action=erase&kb_id=".$t2['id']."\">effacer</a></td>";
        echo "</tr>\n";
      }
      echo "</table>\n";
    }
  }

  function kb_add_admin ()
  {
    global $REQUEST_METHOD;
    global $kb_what;
    global $kb_name, $kb_tag; 
    global $kb_url, $kb_nom_url, $kb_auteur, $kb_sect, $kb_lang;

    if ($REQUEST_METHOD == "POST")
    {
      if ($kb_what == "section")
      {
        $r = $this->db_query ("select * from url_section order by ordre desc;");
        $t = pg_Fetch_Array ($r, 0);
        $section_number = $t['ordre'];
        $section_number ++;
        $this->db_query ("insert into url_section (nom, ordre, tag) values ('".$kb_name."', $section_number, '".$kb_tag."');")
          or die("Requete incorrecte");
        echo "Section ajoute<br><br>";
      }

      if ($kb_what == "url")
      {
        $this->db_query ("insert into urls (url, nom_url,auteur, url_section, lang) values ('".$kb_url."', '".$kb_nom_url."', '".$kb_auteur."', $kb_sect, $kb_lang);")
          or die("Requete incorrecte");
        echo "Url ajoute.<br><br>";
      }
    }
?>
<b>Sections</b><br><br>
<form action=adm.php?p=kb&kb_action=kb_add method=POST>
<table border=0>
<input type=hidden name=kb_what value=section>
<tr>
<td>Nom:</td><td><input type=text name=kb_name size=50></td>
</tr><tr>
<td>tag html:</td><td><input type=text name=kb_tag> (juste un petit mot simple.)</td></tr>
<tr>
<td colspan=2><input type=submit value='Soumettre'></td>
</tr>
</table>
</form>

<b>Urls</b><br><br>
<form  action=adm.php?p=kb&kb_action=kb_add method=POST>
<table border=0>
<input type=hidden name=kb_what value=url>
<tr><td>Url</td><td><input type=text name=kb_url size=50> (http:// requis.)</td></tr>
<tr><td>Nom</td><td><input type=text name=kb_nom_url size=50></td></tr>
<tr><td>Auteur</td><td><input type=text name=kb_auteur size=50></td></tr>
<tr><td>Section</td><td>
<select name=kb_sect>
<?
  $r = $this->db_query ("select * from url_section;");
  for ($i = 0; $i < pg_numrows ($r); $i ++)
  {
    $t = pg_Fetch_Array ($r, $i);
    echo "<option value=".$t['id'].">".$t['nom']."</option>";
  }

?>
</select>
</td></tr>
<tr><td>Langage
</td><td>
<select name=kb_lang>
<option value=1>Francais</option>
<option value=0>Autres</option>
</select>
</td></tr>
<tr><td colspan=2><input type=submit value='Soumettre'></td></tr>
</table>
</form>
<?
  }

  /************************************************************************/

  function sql_admin ()
  {
    global $REQUEST_METHOD;
    global $f_sql;

    echo "<b>Requete SQL</b><br><br>";

?>
<form method=POST action=adm.php?p=sql>
Sql: <input type=text size=50 name=f_sql value='<?
if ($f_sql == "") echo "select * from news;";
else echo "$f_sql";
?>'><br>
<input type=submit value='Valider'>
</form>
<a href=adm.php>Retour au menu principal</a><br>
<?

    if ($REQUEST_METHOD == "POST")
    {
      echo "<br><b>Rsultat: $f_sql</b>";
      $r = $this->db_query ("$f_sql");
      echo "<table border=1><tr>\n";
      for ($i = 0; $i < pg_numfields ($r); $i ++)
      {
        echo "<td>".pg_FieldName($r, $i)."</td>";
      }
      echo "</tr>\n";

      for ($i = 0; $i < pg_numrows ($r); $i ++)
      {
        $t = pg_Fetch_Array ($r, $i);
        echo "<tr>";
        for ($j = 0; $j < pg_numfields ($r); $j ++)
        {
          $a = pg_FieldName($r, $j);
          echo "<td>".$t[$a]."</td>";
        }
        echo "</tr>";
      }
      echo "</table>\n";
    }
  }

  /************************************************************************/

  function forbid_admin ()
  {
    // adm.php?p=forbid
    global $REQUEST_METHOD;
    global $f_dimdam, $forbid_delete;

    echo "<b>Administration d'accs au site web.</b><br><br>\n";

    if ($forbid_delete != "")
    {
      $sql = "delete from forbid where id = $forbid_delete";
      $this->db_query ($sql);
    }

    if ($REQUEST_METHOD == "POST" && $f_dimdam != "")
    {
      $sql = "insert into forbid (host) values ('$f_dimdam');";
      $this->db_query ($sql); 
      echo "$f_dimdam ajout<br><br>";
    }

    $r = $this->db_query ("select * from forbid order by host;");
    if (pg_numrows ($r) > 0)
    {
?>
<table border=1>
<tr><td colspan=2>Hosts (regexp) interdits:</td></tr>
<?
    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      echo "<tr>";
      $t = pg_Fetch_Array ($r, $i);
      echo "<td>".$t['host']."</td>";
      echo "<td><a href=adm.php?p=forbid&forbid_delete=".$t['id'].">effacer</a></td>";
      echo "</tr>";
    }
?>
</table><br>
<?
    }
?>
<br>
<form method=POST action=adm.php?p=forbid>
<table border=0>
<tr><td>Host (Regexp)  interdire:</td><td><input type=text size=30 name=f_dimdam>
</td></tr>
<tr><td colspan=2>
<div align=center><input type=submit value='Soumettre'></div>
</td></tr>
</table>
</form>
<?
    echo "<br><a href=adm.php>Retour au menu principal</a><br>";
    return ;
  }

  /*************************************************************************/

  function projects_admin ()
  {
    /* id projet note body ordre */
    global $REQUEST_METHOD;
    global $prj_action;

    echo "Administration des projets.<br><br>";

    switch ($prj_action)
    {
      case 'del': $this->prj_delmod ();
      default: $this->prj_list (); break;
      case 'mod': $this->prj_ajmod (); break;
      case 'ajt': $this->prj_ajmod (); break;
    }
    echo "<br><a href=adm.php?p=projects>Retour  l'adm. des projets</a>";
    echo "<br><a href=adm.php>Retour au menu principal</a><br>";
    return ;
  }

  function prj_delmod ()
  {
    global $prj_id;
    $sql = "delete from projets where id = $prj_id;";
    $this->db_query($sql);
  }

  function prj_list ()
  {
    $sql = "select * from projets order by ordre desc;";

    $r = $this->db_query ($sql);
    echo "<table border=1>";
    echo "<tr>";
    echo "<td>id</td><td>projet</td><td>note</td><td>&nbsp;</td><td>&nbsp;</td>";
    echo "</tr>\n";
    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      $t = pg_Fetch_Array ($r, $i);
      echo "<tr><td>".$t['id']."</td><td>".$t['projet']."</td>";
      echo "<td>".$t['note']."</td>";
      echo "<td><a href=adm.php?z=projects&prj_action=mod&prj_id=".$t['id'].">modifier</a></td>";
      echo "<td><a href=adm.php?z=projects&prj_action=del&prj_id=".$t['id'].">effacer</a></td>";
      echo "</tr>\n";
    }
    echo "</table><br>";

    echo "<a href=adm.php?p=projects&prj_action=ajt>Ajout d'un projet</a>";
    return ;
  }

  function prj_ajmod ()
  {
    global $prj_id;
    global $prj_action;
    global $f_projet, $f_note, $f_desc;
    global $REQUEST_METHOD;

    if ($REQUEST_METHOD == "POST")
    {
      if ($prj_action == 'mod')
      {
        $sql = "update projets set projet='$f_projet', note='$f_note', body='$f_desc' where id='$prj_id';"; 
        $this->db_query ($sql);
      }
      if ($prj_action == 'ajt')
      {
        $sql = "select * from projets order by ordre desc";
        $r = $this->db_query ($sql);
        $t = pg_Fetch_Array ($r, 0);
        $ord = $t['ordre'] + 1;
        $sql = "insert into projets (projet, note, body, ordre) values ('$f_projet', '$f_note', '$f_desc', $ord);";
        $this->db_query ($sql);
        $sql = "select id from projets where ordre=$ord";
        $r = $this->db_query ($sql);
        $t = pg_Fetch_Array ($r, 0);
        $prj_action = 'mod'; $prj_id = $t['id']; 
      }
    }

    if ($prj_action == 'mod')
    {
      $sql = "select * from projets where id = $prj_id;"; 
      $r = $this->db_query($sql);
      $t = pg_Fetch_Array ($r, 0);
    }
?>
<form method=post action=adm.php?z=projects&prj_action=<?echo $prj_action;?>>
Projet:<br>
<input type=hidden name=prj_id value=<?echo $prj_id;?>>
<input name=f_projet type=text size=60 <?if ($prj_action == 'mod') echo "value='".$t['projet']."'";?>><br>
Note:<br>
<input name=f_note type=text size=80 <?if ($prj_action == 'mod') echo "value='".$t['note']."'";?>'><br>
Description:<br>
<textarea rows=20 cols=80 name=f_desc>
<?if ($prj_action == 'mod') echo $t['body'];?>
</textarea><br>
<input type=submit value=<?if ($prj_action == 'mod') echo "Modifier"; else echo "Ajouter";?>>
</form>
<?
    return ;
  }

  /*************************************************************************/

  function releases_admin ()
  {
    global $REQUEST_METHOD;
    global $rel_action;

    echo "Administration des releases.<br><br>";

    switch ($rel_action)
    {
      case 'del': $this->rel_delmod ();
      default: $this->rel_list (); break;
      case 'mod': $this->rel_ajmod (); break;
      case 'ajt': $this->rel_ajmod (); break;
    }
    echo "<br><a href=adm.php?p=releases>Retour  l'adm. des releases</a>";
    echo "<br><a href=adm.php>Retour au menu principal</a><br>";
    return ;
  }

  function rel_delmod ()
  {
    global $rel_id;
    $sql = "delete from releases where id = $rel_id;";
    $this->db_query($sql);
  }

  function rel_list ()
  {
    $sql = "select * from releases order by ordre desc;";

    $r = $this->db_query ($sql);
    echo "<table border=1>";
    echo "<tr>";
    echo "<td>id</td><td>releases</td><td>note</td><td>&nbsp;</td><td>&nbsp;</td>";
    echo "</tr>\n";
    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      $t = pg_Fetch_Array ($r, $i);
      echo "<tr><td>".$t['id']."</td><td>".$t['release']."</td>";
      echo "<td>".$t['descrip']."</td>";
      echo "<td><a href=adm.php?z=releases&rel_action=mod&rel_id=".$t['id'].">modifier</a></td>";
      echo "<td><a href=adm.php?z=releases&rel_action=del&rel_id=".$t['id'].">effacer</a></td>";
      echo "</tr>\n";
    }
    echo "</table><br>";

    echo "<a href=adm.php?p=releases&rel_section=ajt>Ajout d'une release</a>";
    return ;
  }

  function rel_ajmod ()
  {
    global $rel_id;
    global $rel_action;
    global $f_release, $f_url, $f_author, $f_descrip; 
    global $REQUEST_METHOD;

    if ($REQUEST_METHOD == "POST")
    {
      if ($rel_action == 'mod')
      {
        $sql = "update releases set release='$f_release', url='$f_url', author='$f_author', descrip='$f_descrip' where id='$rel_id';";
        $this->db_query ($sql);
      }
      if ($rel_action == 'ajt')
      {
        $sql = "select * from releases order by ordre desc";
        $r = $this->db_query ($sql);
        $t = pg_Fetch_Array ($r, 0);
        $ord = $t['ordre'] + 1;
        $sql = "insert into releases (release, url, author, descrip, ordre) values ('$f_release', '$f_url', '$f_author', '$f_descrip', $ord);";
        $this->db_query ($sql);
        $sql = "select id from releases where ordre=$ord";
        $r = $this->db_query ($sql);
        $t = pg_Fetch_Array ($r, 0);
        $rel_action = 'mod'; $rel_id = $t['id'];
      }
    }

    if ($rel_action == 'mod')
    {
      $sql = "select * from releases where id = $rel_id;";
      $r = $this->db_query($sql);
      $t = pg_Fetch_Array ($r, 0);
    }
?>

<form method=post action=adm.php?z=releases&rel_action=<?echo $rel_action;?>>
Release:<br>
<input type=hidden name=rel_id value=<?echo $rel_id;?>>
<input name=f_release type=text size=60 <?if ($rel_action == 'mod') echo "value='".$t['release']."'";?>><br>
Url:<br>
<input name=f_url type=text size=60 <?if ($rel_action == 'mod') echo "value='".$t['url']."'";?>><br>
Auteur:<br>
<input name=f_author type=text size=80 <?if ($rel_action == 'mod') echo "value='".$t['author']."'";?>><br>
Description:<br>
<textarea rows=20 cols=80 name=f_descrip>
<?if ($rel_action == 'mod') echo $t['descrip'];?>
</textarea><br>
<input type=submit value=<?if ($rel_action == 'mod') echo "Modifier"; else echo "Ajouter";?>>
</form>
<?
    return ;
  }

  /*************************************************************************/
 
  function papers_admin ()
  {
    global $REQUEST_METHOD;
    global $papers_action;

    echo "Administration des articles.<br><br>";

    switch ($papers_action)
    {
      case 'del': $this->papers_delmod ();
      default: $this->papers_list (); break;
      case 'mod': $this->papers_ajmod (); break;
      case 'ajt': $this->papers_ajmod (); break;
    }
    echo "<br><a href=adm.php?p=papers>Retour  l'adm. des articles</a>";
    echo "<br><a href=adm.php>Retour au menu principal</a><br>";
    return ;
  }

  function papers_delmod ()
  {
    global $papers_id;
    $sql = "delete from papers where id = $papers_id;";
    $this->db_query($sql);
  }

  function papers_list ()
  {
    $sql = "select * from papers order by ordre desc;";

    $r = $this->db_query ($sql);
    echo "<table border=1>";
    echo "<tr>";
    echo "<td>id</td><td>article</td><td>descrip</td><td>&nbsp;</td><td>&nbsp;</td>";
    echo "</tr>\n";
    for ($i = 0; $i < pg_numrows ($r); $i ++)
    {
      $t = pg_Fetch_Array ($r, $i);
      echo "<tr><td>".$t['id']."</td><td>".$t['paper']."</td>";
      echo "<td>".$t['descrip']."</td>";
      echo "<td><a href=adm.php?z=papers&papers_action=mod&papers_id=".$t['id'].">modifier</a></td>";
      echo "<td><a href=adm.php?z=papers&papers_action=del&papers_id=".$t['id'].">effacer</a></td>";
      echo "</tr>\n";
    }
    echo "</table><br>";

    echo "<a href=adm.php?p=papers&papers_action=ajt>Ajout d'un article</a>";
    return ;
  }

  function papers_ajmod ()
  {
    global $papers_id;
    global $papers_action;
    global $f_paper, $f_url, $f_author, $f_descrip;
    global $REQUEST_METHOD;

    if ($REQUEST_METHOD == "POST")
    {
      if ($papers_action == 'mod')
      {
        $sql = "update papers set paper='$f_paper', descrip='$f_paper', url='$f_url', author='$f_author';";
        $this->db_query ($sql);
      }
      if ($papers_action == 'ajt')
      {
        $sql = "select * from papers order by ordre desc";
        $r = $this->db_query ($sql);
        $t = pg_Fetch_Array ($r, 0);
        $ord = $t['ordre'] + 1;
        $sql = "insert into papers (paper, descrip, author, url, ordre) values ('$f_paper', '$f_descrip', '$f_author', '$f_url', $ord);";
        $this->db_query ($sql);
        $sql = "select id from papers where ordre=$ord";
        $r = $this->db_query ($sql);
        $t = pg_Fetch_Array ($r, 0);
        $papers_action = 'mod'; $papers_id = $t['id'];
      }
    }

    if ($papers_action == 'mod')
    {
      $sql = "select * from papers where id = $papers_id;";
      $r = $this->db_query($sql);
      $t = pg_Fetch_Array ($r, 0);
    }
?>
<form method=post action=adm.php?z=papers&papers_action=<?echo $papers_action;?>>
Projet:<br>
<input type=hidden name=papers_id value=<?echo $papers_id;?>>
<input name=f_paper type=text size=60 <?if ($papers_action == 'mod') echo "value='".$t['paper']."'";?>><br>
Url:<br>
<input name=f_url type=text size=80 <?if ($papers_action == 'mod') echo "value='".$t['url']."'";?>><br>
Auteur:<br>
<input name=f_author type=text size=80 <?if ($papers_action == 'mod') echo "value='".$t['author']."'";?>><br>
Description:<br>
<textarea rows=20 cols=80 name=f_descrip>
<?if ($papers_action == 'mod') echo $t['descrip'];?>
</textarea><br>
<input type=submit value=<?if ($papers_action == 'mod') echo "Modifier"; else echo "Ajouter";?>>
</form>
<?
    return ;
  }

}
?>
